<?php
/**
 * DokuWiki Plugin imagewatermark (Syntax Component)
 *
 * @license GPL 2 http://www.gnu.org/licenses/gpl-2.0.html
 * @author  Donghua Gu <gudonghua@gmail.com>
 */

// must be run within Dokuwiki
if (!defined('DOKU_INC')) die();

if (!defined('DOKU_LF')) define('DOKU_LF', "\n");
if (!defined('DOKU_TAB')) define('DOKU_TAB', "\t");
if (!defined('DOKU_PLUGIN')) define('DOKU_PLUGIN',DOKU_INC.'lib/plugins/');

require_once DOKU_PLUGIN.'syntax.php';

class syntax_plugin_imagewatermark_watermark extends DokuWiki_Syntax_Plugin {
    public function getType() {
        #return 'FIXME: container|baseonly|formatting|substition|protected|disabled|paragraphs';
        return 'substition';
    }

    public function getPType() {
        #return 'FIXME: normal|block|stack';
        return 'block';
    }

    public function getSort() {
        #return FIXME;
        return 1;
    }


    public function connectTo($mode) {
        $this->Lexer->addSpecialPattern('<watermark.*?>.*?</watermark>',$mode,'plugin_imagewatermark_watermark');
//        $this->Lexer->addEntryPattern('<FIXME>',$mode,'plugin_imagewatermark_watermark');
    }

//    public function postConnect() {
//        $this->Lexer->addExitPattern('</FIXME>','plugin_imagewatermark_watermark');
//    }

    public function handle($match, $state, $pos, &$handler){
        $data = array();
        $img_id_patt = '</?watermark[^>]*>';
        $img_id = eregi_replace($img_id_patt, "", $match);
        $data['img_id'] = $img_id;
        return $data;
    }

    public function render($mode, &$renderer, $data) {
        if($mode != 'xhtml') return false;
        $renderer->doc .= "<div>";
        $img_id = $data['img_id'];
        $src = mediaFN($img_id);
        $img_water_id = 'watermarkimg:' . $img_id;
        $img_water_id = str_replace("::", ":", $img_water_id);
        $dest = mediaFN($img_water_id);

        $path_parts = pathinfo($dest);
        $dest_dir = $path_parts['dirname'];
        if (is_file($dest)) {
        } else {
            if (!is_dir($dest_dir)){
                mkdir($dest_dir, $mode = 0777 , $recursive=true);
            }
            $this->watermarkImage($src, "www.gpmems.com", $dest);
        }
        $renderer->doc .= "<img src=\"". ml($img_water_id) . "\" />";
        $renderer->doc .= "</div>";
        return true;
    }
    public function watermarkImage ($SourceFile, $WaterMarkText, $DestinationFile) { 
       if(!$SourceFile || !$DestinationFile){ return; }
       list($width, $height) = getimagesize($SourceFile);
       $image_p = imagecreatetruecolor($width, $height);
       $image = imagecreatefromjpeg($SourceFile);
       imagecopyresampled($image_p, $image, 0, 0, 0, 0, $width, $height, $width, $height); 
       $black = imagecolorallocate($image_p, 0, 0, 0);
       $font = DOKU_INC . '/lib/plugins/imagewatermark/arial.ttf';
       $font_size = 16; 
       $text_length = strlen($WaterMarkText);
       imagettftext($image_p, $font_size, 0, $width - $text_length*14,
                    $height - 30, $black, $font, $WaterMarkText);
       imagejpeg ($image_p, $DestinationFile, 80); 
       imagedestroy($image); 
       imagedestroy($image_p); 
    }
}

// vim:ts=4:sw=4:et:
